class IssuesController < ApplicationController
  # GET /issues
  # GET /issues.json
  def index
    if !session[:user].nil?
      u = User.find session[:user]
      @issues = u.get_issues_page params[:page]
    else
      @issues = Issue.all
    end
    #issue = Issue.new(:deadline=>Time.now, :status=>1,:priority=>5, :label=>"Todo", :description=>"Urgent todo")
    #issue.id = 1
    #@issues = [ issue ]
    
    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @issues }
    end
  end

  # GET /issues/1
  # GET /issues/1.json
  def show
    @issue = Issue.find(params[:id])
    @attachments = @issue.get_attachments_page params[:attachment]

    #@issue = Issue.new(:deadline=>Time.now, :status=>1,:priority=>5, :label=>"Todo", :description=>"Urgent todo")

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @issue }
    end
  end

  # GET /issues/new
  # GET /issues/new.json
  def new
    @issue = Issue.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @issue }
    end
  end

  # GET /issues/1/edit
  def edit
    @issue = Issue.find(params[:id])
  end

  # POST /issues
  # POST /issues.json
  def create
    @issue = Issue.new(params[:issue])

    respond_to do |format|
      if @issue.save
        format.html { redirect_to @issue, notice: 'Issue was successfully created.' }
        format.json { render json: @issue, status: :created, location: @issue }
      else
        format.html { render action: "new" }
        format.json { render json: @issue.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /issues/1
  # PUT /issues/1.json
  def update
    @issue = Issue.find(params[:id])

    respond_to do |format|
      if @issue.update_attributes(params[:issue])
        format.html { redirect_to @issue, notice: 'Issue was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @issue.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /issues/1
  # DELETE /issues/1.json
  def destroy
    @issue = Issue.find(params[:id])
    @issue.destroy

    respond_to do |format|
      format.html { redirect_to issues_url }
      format.json { head :no_content }
    end
  end
  
  def upload
    if !session[:user].nil?
      if !params[:upload].nil?
        Attachment.save_file session[:user], params[:id], params[:upload]
        flash[:file] = "File uploaded successfully"
      else
        flash[:file] = "Empty file field"
      end
    else
      flash[:file] = "Please log in to upload file"
    end
    @issue = Issue.find params[:id]
    redirect_to issue_url(@issue)
  end
  
  def download
    a = Attachment.find params[:aid]
    if !a.nil?
      file = Rails.root.join("public", "data", params[:id], a.file)
      send_file file, :disposition => 'inline', :type => a.mime
    else
      @issue = Issue.find params[:id]
      redirect_to issue_url(@issue)
    end
  end
  
  def reassign
    p = params[:issue]
    responsible_user = User.find p['user_id']
    @issue = Issue.find params[:id]
    if !responsible_user.nil?
      @issue.user = responsible_user
      @issue.save
    end
    redirect_to issue_url(@issue)
  end
end
