require 'test_helper'

class IssuesControllerTest < ActionController::TestCase
  def setup
    @issue = issues(:one)
  end
  
  def teardown
    @issue = nil
  end
  
  test "downloads mapped to issues download" do
    assert_routing '/downloads/1/1', {:controller=>'issues', 
      :action=>'download', :id=> '1', :aid=>'1'}
  end

  test "should get index" do
    get :index, :page=>1
    assert_response :success
    assert_not_nil assigns(:issues)
  end

  test "should get new" do
    get :new
    assert_response :success
  end

  test "should create issue" do
    assert_difference('Issue.count') do
      post :create, issue: @issue.attributes
    end

    assert_redirected_to issue_path(assigns(:issue))
  end

  test "should show issue" do
    get :show, id: @issue
    assert_response :success
    assert_select 'td', 1
  end

  test "should get edit" do
    get :edit, id: @issue
    assert_response :success
  end

  test "should update issue" do
    put :update, id: @issue, issue: @issue.attributes
    assert_redirected_to issue_path(assigns(:issue))
  end

  test "should destroy issue" do
    assert_difference('Issue.count', -1) do
      delete :destroy, id: @issue
    end

    assert_redirected_to issues_path
  end
end
